
; Copia um texto para um destino
; ds:si = Origem
; es:di = Destino
; cx = Capacidade
_TxtCopiar:
    push ax
    push si
    push di
    push cx
    .copiar:
        lodsb
        stosb
        cmp al, 0
        je .fim
        loop .copiar
    .fim:
    pop cx
    pop di
    pop si
    pop ax
    retf


; Copia um texto para um destino local
; ds:si = Origem
; ds:di = Destino
; cx = Capacidade
_TxtCopiarLocal:
    push ax
    push si
    push di
    push cx
    push es
    push ds
    pop es
    .copiar:
        lodsb
        stosb
        cmp al, 0
        je .fim
        loop .copiar
    .fim:
    pop es
    pop cx
    pop di
    pop si
    pop ax
    retf


; Copia um texto remoto para um destino remoto
; es:si = Origem
; es:di = Destino
; cx = Capacidade
_TxtCopiarRemoto:
    push ax
    push si
    push di
    push cx
    push es
    push ds
    pop es
    .copiar:
        lodsb
        stosb
        cmp al, 0
        je .fim
        loop .copiar
    .fim:
    pop es
    pop cx
    pop di
    pop si
    pop ax
    retf
    
; Igual
; ds:si = Texto 1
; es:di = Texto 2
; ret: cf = 1=Igual | 0=Diferente
_TxtIgual:
    push ax
    push si
    push di
    .comparar:
        lodsb
        es cmp al, [di]
        jne .diferente
        inc di
        cmp al, 0
        je .igual
        jmp .comparar
    .diferente:
        clc
        jmp .fim
    .igual:
        stc
    .fim:
    pop di
    pop si
    pop ax
    retf

    
; Igual Local
; ds:si = Texto 1
; ds:di = Texto 2
; ret: cf = 1=Igual | 0=Diferente
_TxtIgualLocal:
    push ax
    push si
    push di
    .comparar:
        lodsb
        ds cmp al, [di]
        jne .diferente
        inc di
        cmp al, 0
        je .igual
        jmp .comparar
    .diferente:
        clc
        jmp .fim
    .igual:
        stc
    .fim:
    pop di
    pop si
    pop ax
    retf
    
    
; Igual Remoto
; es:si = Texto 1
; es:di = Texto 2
; ret: cf = 1=Igual | 0=Diferente
_TxtIgualRemoto:
    push ax
    push si
    push di
    .comparar:
        es lodsb
        es cmp al, [di]
        jne .diferente
        inc di
        cmp al, 0
        je .igual
        jmp .comparar
    .diferente:
        clc
        jmp .fim
    .igual:
        stc
    .fim:
    pop di
    pop si
    pop ax
    retf

; Calcula tamanho do texto
; cx = Capacidade
; ds:si = Texto
; ret: cx = Tamanho
_TxtTamLocal:
    push si
    push ax
    push bx
    xor bx, bx
    .calcular:
        lodsb
        cmp al, 0
        je .fim
        inc bx
        loop .calcular
    .fim:
    mov cx, bx
    pop bx
    pop ax
    pop si
    retf

; Calcula tamanho do texto
; cx = Capacidade
; es:si = Texto
; ret: cx = Tamanho
_TxtTamRemoto:
    push si
    push ax
    push bx
    xor bx, bx
    .calcular:
        es lodsb
        cmp al, 0
        je .fim
        inc bx
        loop .calcular
    .fim:
    mov cx, bx
    pop bx
    pop ax
    pop si
    retf
