_termX: dw 0
_termY: dw 0
_termLargura: dw 0
_termAltura: dw 0
_termSegmento: dw 0
_termCorFundo: dw 0
_termCorTexto: dw 0
_termCursor: dw 0

; Inicia o video texto
termIniciar:
    cs mov word [_termSegmento], 0xb800
    cs mov word [_termX], 0
    cs mov word [_termY], 0
    cs mov word [_termAltura], 25
    cs mov word [_termLargura], 80
    cs mov word [_termCorFundo], 0
    cs mov word [_termCorTexto], 3
    call termLimpar
    call termOcultarCursor
    ret

; Oculta o cursor da tela
termOcultarCursor:
    push dx
    push ax
    mov dx, 0x3d4
    mov al, 0xa
    out dx, al
    mov dx, 0x3d5
    mov al, 0x20
    out dx, al
    cs mov word [_termCursor], 0
    pop ax
    pop dx
    ret

; Exibe o cursor na tela
termExibirCursor:
    push ax
    push dx
    mov dx, 0x3d4
    mov al, 0xa
    out dx, al
    
    mov dx, 0x3d5
    in al, dx
    and al, 0xc0
    or al, 14
    out dx, al
    
    mov dx, 0xd4
    mov al, 0xb
    out dx, al
    mov dx, 0x3d5
    in al, dx
    and al, 0xc0
    or al, 15
    out dx, al
    
    cs mov word [_termCursor], 0
    pop dx
    pop ax
    ret
    
; Limpa a tela
termLimpar:
    push ax
    push cx
    push es
    push di
    
    cs mov ax, [_termSegmento]
    mov es, ax
    
    cs mov ax, [_termAltura]
    cs mul word [_termLargura]
    mov bx, ax
    
    cs mov ax, [_termCorFundo]
    mov cl, 4
    shl ax, cl
    cs add ax, [_termCorTexto]
    mov cl, 8
    shl ax, cl
    add ax, ' '
    
    mov cx, bx
    
    xor di, di
    
    rep stosw
    
    pop di
    pop es
    pop cx
    pop ax
    ret

; Escreve um caractere em AL com os parametros atuais
; al = Caractere
termEscreverC:
    push ax
    push bx
    push cx
    push es
    
    cmp al, 13
    jne .nao13
        cs mov word [_termX], 0
    .nao13:
    cmp al, 10
    jne .nao10
        cs inc word [_termY]
    .nao10:
    
    cs mov bx, [_termCorFundo]
    mov cl, 4
    shl bx, cl
    cs add bx, [_termCorTexto]
    mov cl, 8
    shl bx, cl
    mov bl, al
    
    cs mov ax, [_termLargura]
    cs cmp [_termX], ax
    jb .continuaX
        mov word [_termX], 0
        inc word [_termY]
    .continuaX:
    
    cs mov ax, [_termAltura]
    cs cmp [_termY], ax
    jb .continuaY
        mov word [_termY], 0
    .continuaY:
    
    cs mov ax, [_termY]
    cs mul word [_termLargura]
    cs add ax, [_termX]
    
    xchg ax, bx
    cs push word [_termSegmento]
    pop es
    shl bx, 1
    
    cmp al, 32
    jb .fim
    es mov [bx], ax
    cs inc word [_termX]
    
    cs cmp word [_termCursor], 0
    je .fim
        shr bx, 1
        mov dx, 0x3d4
        mov al, 0xf
        out dx, al
        mov al, bl
        mov dx, 0x3d5
        out dx, al
        mov dx, 0x3d4
        mov al, 0xe
        out dx, al
        mov al, bh
        mov dx, 0x3d5
        out dx, al
    
    .fim:
    pop es
    pop cx
    pop bx
    pop ax
    ret

; Escreve um ponto
termPonto:
    pushf
    call termEscrever
    db ".",0
    popf
    ret

; Escreve um numero na tela
; ax = Numero
termEscreverIntSinal:
    pushf
    push ax
    cmp ax, 0
    jge .numero
        neg ax
        call termEscrever
        db "-",0
    .numero:
    call termEscreverInt
    .fim:
    pop ax
    popf
    ret

; Escreve um numero na tela
; ax = Numero
termEscreverInt:
    pushf
    push ax
    push bx
    push dx
    xor dx, dx
    cs div word [.divisao]
    cmp ax, 0
    je .fim
        call termEscreverInt
    .fim:
    mov ax, dx
    mov bx, .tabela
    xlat
    call termEscreverC
    pop dx
    pop bx
    pop ax
    popf
    ret
    .divisao: dw 10
    .tabela: db '0123456789'

; Escreve um numero Hexadecimal na tela
; ax = Numero
termEscreverHex:
    pushf
    push ax
    push bx
    push dx
    xor dx, dx
    cs div word [.divisao]
    cmp ax, 0
    je .fim
        call termEscreverHex
    .fim:
    mov ax, dx
    mov bx, .tabela
    xlat
    call termEscreverC
    pop dx
    pop bx
    pop ax
    popf
    ret
    .divisao: dw 16
    .tabela: db '0123456789ABCDEF'
    
; Escreve um texto na tela
; ds:si = texto
termEscreverLocal:
    pushf
    push bp
    mov bp, sp
    push si
    push ax
    .repetir:
        lodsb
        cmp al, 0
        je .fim
        call termEscreverC
        jmp .repetir
    .fim:
    pop ax
    pop si
    mov sp, bp
    pop bp
    popf
    ret
    
; Escreve um texto na tela
; es:si = texto
termEscreverRemoto:
    pushf
    push bp
    mov bp, sp
    push si
    push ax
    push ds
    push es
    pop ds
    .repetir:
        lodsb
        cmp al, 0
        je .fim
        call termEscreverC
        jmp .repetir
    .fim:
    pop ds
    pop ax
    pop si
    mov sp, bp
    pop bp
    popf
    ret

; Escreve um texto fixo na tela
; cs:ip = Texto
; 
; Comandos de escape simples
;  \n - Nova linha
; Comandos de escape compostos
;  Formato: \[origem][ação]
;  Origens:
;   a - AX
;   b - BX
;   c - CX
;   d - DX
;   e - SI
;   f - DI
;  Ações:
;   i - Imprime um numero inteiro positivo
;   s - Imprime um numero inteiro positivo ou negativo
;   h - Imprime um numero hexadecimal
;   t - Imprime um texto em DS:[Origem]
;   r - Imprime um texto remoto em ES:[Origem]
;  Exemplos:
;   \et - Imprime um texto em DS:SI
;   \ch - Imprime um numero hexadecimal em CX
;   \bi - Imprime um numero em BX
;
termEscrever:
    push bp
    mov bp, sp
    .a: equ -2
    .b: equ -4
    .c: equ -6
    .d: equ -8
    .e: equ -10
    .f: equ -12
    push ax
    push bx
    push cx
    push dx
    push si
    push di
    
    push si
    push ax
    push bx
    mov si, [bp + 2]
    .repetir:
        cs lodsb
        cmp al, 0
        jne .nao_zero
            jmp .fim
        .nao_zero:
        cmp al, '\'
        je .especial
            jmp .comum
        .especial:
            cs lodsb
            cmp al, 'a'
            je .barraA
            cmp al, 'b'
            je .barraB
            cmp al, 'c'
            je .barraC
            cmp al, 'd'
            je .barraD
            cmp al, 'e'
            je .barraE
            cmp al, 'f'
            je .barraF
            cmp al, 'n'
            je .barraN
            cmp al, 't'
            je .barraT
            jmp .comum
            .barraA:
                mov bx, [bp+.a]
                jmp .saida
            .barraB:
                mov bx, [bp+.b]
                jmp .saida
            .barraC:
                mov bx, [bp+.c]
                jmp .saida
            .barraD:
                mov bx, [bp+.d]
                jmp .saida
            .barraE:
                mov bx, [bp+.e]
                jmp .saida
            .barraF:
                mov bx, [bp+.f]
                jmp .saida
            .barraN:
                mov al, 13
                call termEscreverC
                mov al, 10
                jmp .comum
            .barraT:
                mov al, 32
                jmp .comum
            .saida:
                cs lodsb
                cmp al, 0
                je .fim
                cmp al, 'i'
                je .numero
                cmp al, 's'
                je .sinal
                cmp al, 'h'
                je .hex
                cmp al, 't'
                je .txt
                cmp al, 'r'
                je .rtxt
                jmp .fim
            .numero:
                mov ax, bx
                call termEscreverInt
                jmp .fimC
            .sinal:
                mov ax, bx
                call termEscreverIntSinal
                jmp .fimC
            .hex:
                mov ax, bx
                call termEscreverHex
                jmp .fimC
            .txt:
                push si
                mov si, bx
                call termEscreverLocal
                pop si
                jmp .fimC
            .rtxt:
                push si
                mov si, bx
                call termEscreverRemoto
                pop si
                jmp .fimC
        .comum:
        call termEscreverC
        .fimC:
        jmp .repetir
    .fim:
    mov [bp + 2], si
    pop bx
    pop ax
    pop si
    mov sp, bp
    pop bp
    ret 

; Ir para
; cx = Coluna
; dx = Linha
termIrPara:
    cs mov [_termX], cx
    cs mov [_termY], dx
    ret
    
; Altura
; ret: ax = Altura
termAltura:
    cs mov ax, [_termAltura]
    ret
    
; Largura
; ret: ax = Largura
termLargura:
    cs mov ax, [_termLargura]
    ret

; Imprime os registradores na tela
termEscreverRegs:
    pushf
    push ax
    call termEscrever
    db 13,10,"[AX:",0
    call termEscreverHex
    mov ax, bx
    call termEscrever
    db " BX:",0
    call termEscreverHex
    mov ax, cx
    call termEscrever
    db " CX:",0
    call termEscreverHex
    mov ax, dx
    call termEscrever
    db " DX:",0
    call termEscreverHex
    call termEscrever
    db "] ",0
    pop ax
    popf
    ret
